import axios from 'axios'
import { API_URL } from '../config.json'
import { getCurrentUser } from './oauth2-manager'

export const createClient = () => {
  const client = axios.create({
    baseURL: API_URL,
  })

  client.interceptors.request.use((config) => {
    const user = getCurrentUser()

    if (user !== null) {
      config.headers = {
        'X-AUTH-TOKEN': `${user.accessToken}`,
      }
    }

    return config
  })

  return client
}
