import axios from 'axios'
import { API_URL } from '../config.json'
import AuthManager from './auth-manager'

export const createClient = (authManager: AuthManager) => {
  const client = axios.create({
    baseURL: API_URL,
  })

  client.interceptors.request.use((config) => {
    const user = authManager.getCurrentUser()

    if (user !== null) {
      config.headers = {
        Authorization: `Bearer ${user.accessToken}`,
      }
    }

    return config
  })

  return client
}
