import React from 'react'
import Button from '@material-ui/core/Button'

type Props = {
  actionName: string
  loading?: boolean
  action: () => void
  close: () => void
}

const ActionButtons = ({ actionName, loading, action, close }: Props) => {
  return (
    <div>
      <Button
        disabled={loading}
        color="primary"
        variant="contained"
        style={{ color: 'white', marginRight: '16px' }}
        onClick={action}
      >
        {actionName}
      </Button>
      <Button color="secondary" variant="contained" onClick={close}>
        Close
      </Button>
    </div>
  )
}

export default ActionButtons
