import React from 'react'
import {Contact} from '../../types'
import { ContactAutosuggestByName, ContactAutosuggestByPhone } from './ContactAutosuggest'

type Props = {
  contact: Contact,
  onChangeContact(contact: Contact): void,
}

const ContactPicker = ({ onChangeContact, contact }: Props) => {
  const updatePhone = (phone: string) => onChangeContact({ ...contact, phone })
  const updateName = (name: string) => onChangeContact({ ...contact, name })

  return (
    <div style={{ display: 'flex' }}>
      <label>
        Name:
        <ContactAutosuggestByName
          value={contact.name}
          onChange={(_, event) => updateName(event.newValue)}
          onSelectContact={onChangeContact}
        />
      </label>
      <label>
        Phone:
        <ContactAutosuggestByPhone
          value={contact.phone}
          onChange={(_, event) => updatePhone(event.newValue)}
          onSelectContact={onChangeContact}
        />
      </label>
    </div>
  )
}

export default ContactPicker
