import { withStyles, Theme, createStyles, makeStyles } from '@material-ui/core/styles'
import TableCell from '@material-ui/core/TableCell'
import TableRow from '@material-ui/core/TableRow'
import Pagination from '@material-ui/lab/Pagination'
import { styled } from '@material-ui/core/styles'

export const StyledTableCell = withStyles((theme: Theme) =>
  createStyles({
    head: {
      backgroundColor: theme.palette.secondary.main,
      color: theme.palette.common.white,
    },
    body: {
      fontSize: 14,
    },
  })
)(TableCell)

export const StyledTableRow = withStyles((theme: Theme) =>
  createStyles({
    root: {
      '&:nth-of-type(odd)': {
        backgroundColor: theme.palette.action.hover,
      },
      height: '20px',
    },
  })
)(TableRow)

export const useStyles = makeStyles({
  table: {
    minWidth: 500,
  },
})

export const StyledPagination = styled(Pagination)({
  marginTop: '8px',
  display: 'flex',
  justifyContent: 'space-around',
})
